import pygame
from pygame.locals import *

# Constantes
LARGEUR = 800
HAUTEUR = 600

VMAX = 30

def main():
	# Initialisation
	pygame.init()
	
	fenetre = pygame.display.set_mode((LARGEUR,HAUTEUR))
	horloge = pygame.time.Clock()
	
	c_fond = pygame.Color(255,255,255)
	c_balle = pygame.Color(255,0,0)
	
	x,y = 0,0
	vx,vy = 0,0
	
	while (True):
		# Évènements clavier
		pygame.event.pump()
		clavier = pygame.key.get_pressed()
		if clavier[K_ESCAPE]:
			return 0
		# Accélération
		if clavier[K_RIGHT]:
			vx = min(vx+1, VMAX)
		if clavier[K_LEFT]:
			vx = max(vx-1, -VMAX)
		if clavier[K_DOWN]:
			vy = min(vy+1, VMAX)
		if clavier[K_UP]:
			vy = max(vy-1, -VMAX)
		
		# Bords de l'écran (rebond)
		if (x + vx > LARGEUR or x + vx < 0):
			vx = -vx
		if (y + vy > HAUTEUR or y + vy < 0):
			vy = -vy
		
		# Mouvement
		x = x + vx
		y = y + vy
		
		# Dessin
		fenetre.fill(c_fond)
		pygame.draw.circle(fenetre, c_balle, (x,y), 20, 0)
		
		pygame.display.update()
		
		# Taux de rafraîchissement (60 IPS)
		horloge.tick(60)

main()
